import _classCallCheck from "@babel/runtime/helpers/classCallCheck";
import _createClass from "@babel/runtime/helpers/createClass";

var _dec, _class;

import { encodePickingColor, rgb2arr } from '@antv/l7-utils';
import { injectable } from 'inversify';
var LayerStylePlugin = (_dec = injectable(), _dec(_class = function () {
  function LayerStylePlugin() {
    _classCallCheck(this, LayerStylePlugin);
  }

  _createClass(LayerStylePlugin, [{
    key: "apply",
    value: function apply(layer) {
      layer.hooks.afterInit.tap('LayerStylePlugin', function () {
        layer.updateLayerConfig({});

        var _layer$getLayerConfig = layer.getLayerConfig(),
            autoFit = _layer$getLayerConfig.autoFit;

        if (autoFit) {
          layer.fitBounds();
        }
      });
      layer.hooks.beforeRender.tap('LayerStylePlugin', function () {
        var _layer$getLayerConfig2 = layer.getLayerConfig(),
            _layer$getLayerConfig3 = _layer$getLayerConfig2.highlightColor,
            highlightColor = _layer$getLayerConfig3 === void 0 ? 'red' : _layer$getLayerConfig3,
            _layer$getLayerConfig4 = _layer$getLayerConfig2.pickedFeatureID,
            pickedFeatureID = _layer$getLayerConfig4 === void 0 ? -1 : _layer$getLayerConfig4;

        layer.models.forEach(function (model) {
          return model.addUniforms({
            u_PickingStage: 2.0,
            u_PickingColor: encodePickingColor(pickedFeatureID),
            u_HighlightColor: rgb2arr(highlightColor)
          });
        });
      });
    }
  }]);

  return LayerStylePlugin;
}()) || _class);
export { LayerStylePlugin as default };
//# sourceMappingURL=LayerStylePlugin.js.map